/****************************************************************************
    Qt-LCoV Library Editor for Qt-BSch3V
    Copyright (C) 2002-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

#ifndef SPTNOBJPOLYGON_H
#define SPTNOBJPOLYGON_H

#include "sptnobj.h"

#define VECTPLOYGON_MAXNODE 32	//¿ѷκĺ

class SPtnObjPolygon :
	public SPtnObj
{
public:
	SPtnObjPolygon(void);
	~SPtnObjPolygon(void);
	int id(){return VECTPTN_PG;}
	SPtnObjPolygon(const SPtnObjPolygon&);					//ԡ󥹥ȥ饯
	SPtnObjPolygon& operator=(const SPtnObjPolygon&);		//黻
	SPtnObj* duplicate();							//ʣ
	bool qValid();									//ͭʥǡɤ֤

	//åפο֤
	int gripCount(){return m_nCount;}
	//åפΰ֤֤
	SPoint gripPos(int grip);
	//åפΰ֤ư
	void setGripPos(int grip,int x,int y);

	void move(int offsetx,int offsety);				//֤ư
	void mirrorH(int x); 							//XɸꤷƺȿžԤ
	void mirrorH();									//ȿžԤ
	void rotate(const SPoint& p);					//XY濴ɸꤷơžԤ
	void rotate();									//žԤ
	bool testIntersect(const SRect& );				//ϰϤꤷåԤ
	bool testIntersect(const SPoint& );				//ꤷåԤ
	SRect area();									//ͭϰϤ֤
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,SPoint* pOrigin=NULL);
public:
	int	    m_nCount;		//ĺο
	SPoint* m_pPt;			//ĺɸ
	//int m_nFill;
protected:
	void normalize();
};

#endif

